Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# GeomVertexArrayData Class Reference

This is the data for one array of a GeomVertexData structure. More...

Inheritance diagram for GeomVertexArrayData:

List of all members.

## Public Member Functions
| GeomVertexArrayData (GeomVertexArrayData const copy)
| GeomVertexArrayData (GeomVertexArrayFormat const array_format, UsageHint usage_hint)
| clearRows ()
| Removes all of the rows in the array.
int | compareTo (GeomVertexArrayData const other)
| Returns 0 if the two arrays are equivalent, even if they are not the same pointer.
GeomVertexArrayFormat const | getArrayFormat ()
| Returns the format object that describes this array.
int | getDataSizeBytes ()
| Returns the number of bytes stored in the array.
GeomVertexArrayDataHandle const | getHandle (Thread current_thread)
| Returns an object that can be used to read the actual data bytes stored in the array.
GeomVertexArrayDataHandle const | getHandle ()
| Returns an object that can be used to read the actual data bytes stored in the array.
UpdateSeq | getModified ()
| Returns a sequence number which is guaranteed to change at least every time the array vertex data is modified.
int | getNumRows ()
| Returns the number of rows stored in the array, based on the number of bytes and the stride.
UsageHint | getUsageHint ()
| Returns the usage hint that describes to the rendering backend how often the vertex data will be modified and/or rendered.
bool | hasColumn (InternalName const name)
| Returns true if the array has the named column, false otherwise.
bool | isPrepared (PreparedGraphicsObjects prepared_objects)
| Returns true if the data has already been prepared or enqueued for preparation on the indicated GSG, false otherwise.
GeomVertexArrayDataHandle | modifyHandle (Thread current_thread)
| Returns an object that can be used to read or write the actual data bytes stored in the array.
GeomVertexArrayDataHandle | modifyHandle ()
| Returns an object that can be used to read or write the actual data bytes stored in the array.
| operator new (unsigned int size)
GeomVertexArrayData | operator= (GeomVertexArrayData const copy)
| The copy assignment operator is not pipeline-safe.
| output (ostream out)
| prepare (PreparedGraphicsObjects prepared_objects)
| Indicates that the data should be enqueued to be prepared in the indicated prepared_objects at the beginning of the next frame.
VertexBufferContext | prepareNow (PreparedGraphicsObjects prepared_objects, GraphicsStateGuardianBase gsg)
| Creates a context for the data on the particular GSG, if it does not already exist.
bool | release (PreparedGraphicsObjects prepared_objects)
| Frees the data context only on the indicated object, if it exists there.
int | releaseAll ()
| Frees the context allocated on all objects for which the data has been declared.
bool | requestResident ()
| Returns true if the vertex data is currently resident in memory.
bool | reserveNumRows (int n)
| This ensures that enough memory space for n rows is allocated, so that you may increase the number of rows to n without causing a new memory allocation.
bool | setNumRows (int n)
| Sets the length of the array to n rows.
| setUsageHint (UsageHint usage_hint)
| Changes the UsageHint hint for this array.
bool | uncleanSetNumRows (int n)
| This method behaves like set_num_rows(), except the new data is not initialized.
| write (ostream out, int indent_level)
| write (ostream out)
## Static Public Member Functions
static VertexDataBook | getBook ()
| Returns the global VertexDataBook that will be used to allocate vertex data buffers.
static TypeHandle | getClassType ()
static SimpleLru | getIndependentLru ()
| Returns a pointer to the global LRU object that manages the GeomVertexArrayData's that have not (yet) been paged out.
static SimpleLru | getSmallLru ()
| Returns a pointer to the global LRU object that manages the GeomVertexArrayData's that are deemed too small to be paged out.
static | lruEpoch ()
| Marks that an epoch has passed in each LRU.

## Detailed Description

This is the data for one array of a GeomVertexData structure.

Many GeomVertexData structures will only define one array, with all data elements interleaved (DirectX 8.0 and before insisted on this format); some will define multiple arrays.

DirectX calls this concept of one array a "stream". It also closely correlates with the concept of a vertex buffer.

This object is just a block of data. In general, you should not be directly messing with this object from application code. See GeomVertexData for the organizing structure, and see GeomVertexReader/Writer/Rewriter for high-level tools to manipulate the actual vertex data.

## Constructor & Destructor Documentation

GeomVertexArrayData | ( | GeomVertexArrayData const | copy | ) |

GeomVertexArrayData | ( | GeomVertexArrayFormat const | array_format,
|  | UsageHint | usage_hint
| ) |  |

## Member Function Documentation

clearRows | ( |  | ) |

Removes all of the rows in the array.

Functionally equivalent to set_num_rows(0).

int compareTo | ( | GeomVertexArrayData const | other | ) |

Returns 0 if the two arrays are equivalent, even if they are not the same pointer.

GeomVertexArrayFormat const getArrayFormat | ( |  | ) |

Returns the format object that describes this array.

static VertexDataBook getBook | ( |  | ) | `[static]`

Returns the global VertexDataBook that will be used to allocate vertex data buffers.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from CopyOnWriteObject.

int getDataSizeBytes | ( |  | ) |

Returns the number of bytes stored in the array.

GeomVertexArrayDataHandle const getHandle | ( | Thread | current_thread | ) |

Returns an object that can be used to read the actual data bytes stored in the array.

Calling this method locks the data, and will block any other threads attempting to read or write the data, until the returned object destructs.

GeomVertexArrayDataHandle const getHandle | ( |  | ) |

Returns an object that can be used to read the actual data bytes stored in the array.

Calling this method locks the data, and will block any other threads attempting to read or write the data, until the returned object destructs.

static SimpleLru getIndependentLru | ( |  | ) | `[static]`

Returns a pointer to the global LRU object that manages the GeomVertexArrayData's that have not (yet) been paged out.

UpdateSeq getModified | ( |  | ) |

Returns a sequence number which is guaranteed to change at least every time the array vertex data is modified.

int getNumRows | ( |  | ) |

Returns the number of rows stored in the array, based on the number of bytes and the stride.

This should be the same for all arrays within a given GeomVertexData object.

static SimpleLru getSmallLru | ( |  | ) | `[static]`

Returns a pointer to the global LRU object that manages the GeomVertexArrayData's that are deemed too small to be paged out.

UsageHint getUsageHint | ( |  | ) |

Returns the usage hint that describes to the rendering backend how often the vertex data will be modified and/or rendered.

See geomEnums.h.

bool hasColumn | ( | InternalName const | name | ) |

Returns true if the array has the named column, false otherwise.

This is really just a shortcut for asking the same thing from the format.

bool isPrepared | ( | PreparedGraphicsObjects | prepared_objects | ) |

Returns true if the data has already been prepared or enqueued for preparation on the indicated GSG, false otherwise.

static lruEpoch | ( |  | ) | `[static]`

Marks that an epoch has passed in each LRU.

Asks the LRU's to consider whether they should perform evictions.

GeomVertexArrayDataHandle modifyHandle | ( | Thread | current_thread | ) |

Returns an object that can be used to read or write the actual data bytes stored in the array.

Calling this method locks the data, and will block any other threads attempting to read or write the data, until the returned object destructs.

GeomVertexArrayDataHandle modifyHandle | ( |  | ) |

Returns an object that can be used to read or write the actual data bytes stored in the array.

Calling this method locks the data, and will block any other threads attempting to read or write the data, until the returned object destructs.

operator new | ( | unsigned int | size | ) |

GeomVertexArrayData operator= | ( | GeomVertexArrayData const | copy | ) |

The copy assignment operator is not pipeline-safe.

This will completely obliterate all stages of the pipeline, so don't do it for a GeomVertexArrayData that is actively being used for rendering.

output | ( | ostream | out | ) |

Reimplemented from SimpleLruPage.

prepare | ( | PreparedGraphicsObjects | prepared_objects | ) |

Indicates that the data should be enqueued to be prepared in the indicated prepared_objects at the beginning of the next frame.

This will ensure the data is already loaded into the GSG if it is expected to be rendered soon.

Use this function instead of prepare_now() to preload datas from a user interface standpoint.

VertexBufferContext prepareNow | ( | PreparedGraphicsObjects | prepared_objects,
|  | GraphicsStateGuardianBase | gsg
| ) |  |

Creates a context for the data on the particular GSG, if it does not already exist.

Returns the new (or old) VertexBufferContext. This assumes that the GraphicsStateGuardian is the currently active rendering context and that it is ready to accept new datas. If this is not necessarily the case, you should use prepare() instead.

Normally, this is not called directly except by the GraphicsStateGuardian; a data does not need to be explicitly prepared by the user before it may be rendered.

bool release | ( | PreparedGraphicsObjects | prepared_objects | ) |

Frees the data context only on the indicated object, if it exists there.

Returns true if it was released, false if it had not been prepared.

int releaseAll | ( |  | ) |

Frees the context allocated on all objects for which the data has been declared.

Returns the number of contexts which have been freed.

bool requestResident | ( |  | ) |

Returns true if the vertex data is currently resident in memory.

If this returns true, the next call to get_handle()->get_read_pointer() will probably not block. If this returns false, the vertex data will be brought back into memory shortly; try again later.

bool reserveNumRows | ( | int | n | ) |

This ensures that enough memory space for n rows is allocated, so that you may increase the number of rows to n without causing a new memory allocation.

This is a performance optimization only; it is especially useful when you know ahead of time that you will be adding n rows to the data.

bool setNumRows | ( | int | n | ) |

Sets the length of the array to n rows.

Normally, you would not call this directly, since all of the arrays in a particular GeomVertexData must have the same number of rows; instead, call GeomVertexData.set_num_rows().

The return value is true if the number of rows was changed, false if the object already contained n rows (or if there was some error).

The new vertex data is initialized to 0, including the "color" column (but see GeomVertexData.set_num_rows()).

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

setUsageHint | ( | UsageHint | usage_hint | ) |

Changes the UsageHint hint for this array.

See get_usage_hint().

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

bool uncleanSetNumRows | ( | int | n | ) |

This method behaves like set_num_rows(), except the new data is not initialized.

Furthermore, after this call, *any* of the data in the GeomVertexArrayData may be uninitialized, including the earlier rows.

Normally, you would not call this directly, since all of the arrays in a particular GeomVertexData must have the same number of rows; instead, call GeomVertexData.unclean_set_num_rows().

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

Reimplemented from SimpleLruPage.

write | ( | ostream | out | ) |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties